## ######### PROJECT DESCRIPTION : ###
## 
## gestion commande LXCR xyratex
## 
## ###################################
## 
## Made by Florac Emmanuel
## 
## Started on mer sep 24 15:56:51 2008 Florac Emmanuel
## 
## ###################################
##

## ###################################
## Declaration du package

package Lxcr_v1;

## ###################################
## Appel des librairies

use	strict;
use	Data::Dumper;

## Liste des lib info
use	Lxcr_info_v1;
# use	Lxcr_fct_v1;

## ###################################
## Declaration de variables


my %up_stage_v1 = (
    'info_ctl'	    => \&Lxcr_info_v1::Lxcr_info_ctl,
    'list_ctl'	    => \&Lxcr_info_v1::Lxcr_list_ctl,
    'list_unit'	    => \&Lxcr_info_v1::Lxcr_list_unit,
    'list_port'	    => \&Lxcr_info_v1::Lxcr_list_port,
    'smart'		    => \&Lxcr_info_v1::Lxcr_smart,
    'createunit'    => \&Lxcr_fct_v1::createunit,
    'deleteunit'	=> \&Lxcr_fct_v1::deleteunit,
    'rescan'		=> \&Lxcr_fct_v1::rescan,
    'verify'		=> \&Lxcr_fct_v1::verify,
    'alarms'		=> \&Lxcr_fct_v1::alarms,
    'info'		    => \&Lxcr_info_v1::info,
    'rebuild'	    => \&Lxcr_fct_v1::rebuild,
    'deleteport'	=> \&Lxcr_fct_v1::deleteport,
    'state'		    => \&Lxcr_info_v1::state,
	'bbu'           => \&Lxcr_info_v1::bbu,
    'capacity'      => \&Lxcr_info_v1::capacity,
);

my %i686    = (
    '2.14' => \%up_stage_v1,
    '4.12' => \%up_stage_v1,
    '5.13.0005' => \%up_stage_v1,
    );

my $Lxcr_exe_name    = "/usr/sbin/LXCR";

## ###################################
## ########### FONCTIONS #############
## ###################################

######################################
# appel des fonction ds les librairies
# suivant la version de lxcr
# prends le nom de la fct et les params
# en parametre

sub call {
    my $name	= shift;
    my @param	= @_;

    my $version = test_version_lxcr();

    return 1, "LXCR NOT PRESENT" unless ( $version );

	if ( exists $i686{ $version } ) {
		if (my @ret = $i686{$version}->{$name}(@param)) {
			return @ret;
		}
		else {
			return -1, "Lxcr_info_ctl return null expression";
		}
	}
	else {
		return -1, "UNKNOWN LXCR VERSION";
	}
}

######################################
# test la version de lxcr

sub test_version_lxcr {
    my $name	= $Lxcr_exe_name;

    # return 1 si lxcr n'est pas present
    return unless ( -e $name );
    return unless ( -x $name );

    # On recupere la version de lxcr et on la retourne
    my @version=qx(LXCR -v); 
	chomp @version;  
	my $version = join "", @version ; 
	
    if ( $version =~ /LXCR\s+version:\s+([\d+.]+)/ ) {
        return $1;
    }
    return ;
}

## ###################################
## Fonction info_all :
## appel Lxcr_info et retourne les infos
## si la version est connue

sub info_all {
    return call("info_ctl", @_);
}

## ###################################
## Fonction list_ctl :

sub list_ctl {
    return call("list_ctl", @_);
}

## ###################################
## Fonction list_unit :
## prend un controleur en param

sub list_unit {
    return call("list_unit", @_);
}

## ###################################
## Fonction list_port :
## prend un controleur en param

sub list_port {
    return call("list_port", @_);
}

## ###################################
## Fonction smart :
## prend un controleur et un disk en param

sub smart {
    return call("smart", @_);
}

## ###################################
## Fonction createunit :
##
## createunit($cid, $RaidType, $PidList)

sub createunit {
    return 0, "createunit: Not implemented";
}

## ###################################
## Fonction deleteunit :
## 
## deleteunit($cid, $uid)

sub deleteunit {
    return 0, "deleteunit: Not implemented";
}

## ###################################
## Fonction rescan :
## 
## rescan($cid)

sub rescan {
    return 0, "rescan: Not implemented";
}

## ###################################
## Fonction verify :
## 
## verify($cid, $uid)

sub verify {
    return 0, "verify: Not implemented";
}

## ###################################
## Fonction alarms :
## 
## alarms([$cid]) 

sub alarms {
    return call("alarms", @_);
}

## ###################################
## Fonction info :
## 
## info()

sub info {
   return call("info", @_);
}

## ###################################
## Fonction rebuilt :
## 
## rebuild($cid, $uid, $pid)

sub rebuild {
    return 0, "rebuild: Not implemented";
}

## ###################################
## Fonction deleteport :
## 
## deleteport($cid, $pid)

sub deleteport {
    return 0, "deleteport: Not implemented";
}


## ###################################
## Fonction state :
## 
## state()

sub state {
    return call("state", @_);
}

## ###################################
## Fonction bbu :
sub bbu {
    return call("bbu", @_);
}

## ###################################
## Fonction cache :
sub cache {
    return 0, "Cache: Not implemented";
}

## ###################################
## Fonction capacity :
sub capacity {
    return 0, "capacity: Not implemented";
}

1;
