## ######### PROJECT DESCRIPTION : ###
## 
## ds
## 
## ###################################
## 
## Made by husianycia cedric
## Login   <husiana@intellique.com>
## 
## Started on  Wed Aug 31 17:30:31 2005 husianycia cedric
## Last update Tue Jul 10 16:58:02 2007 Florac Emmanuel
## 
## ###################################
##

## ###################################
## Declaration du package

package MegaCli_v1;

## ###################################
## Appel des librairies

use	strict;
use	Data::Dumper;

## Liste des lib info
use	MegaCli_info_v1;
use	MegaCli_fct_v1;

## ###################################
## Declaration de variables


my %up_stage_v1 = (
    'info_ctl'	    => \&MegaCli_info_v1::megacli_info_ctl,
    'list_ctl'	    => \&MegaCli_info_v1::megacli_list_ctl,
    'list_unit'	    => \&MegaCli_info_v1::megacli_list_unit,
    'list_port'	    => \&MegaCli_info_v1::megacli_list_port,
    'smart'		    => \&MegaCli_info_v1::megacli_smart,
    'createunit'    => \&MegaCli_fct_v1::createunit,
    'deleteunit'	=> \&MegaCli_fct_v1::deleteunit,
    'rescan'		=> \&MegaCli_fct_v1::rescan,
    'verify'		=> \&MegaCli_fct_v1::verify,
    'alarms'		=> \&MegaCli_fct_v1::alarms,
    'info'		    => \&MegaCli_fct_v1::info,
    'rebuild'	    => \&MegaCli_fct_v1::rebuild,
    'deleteport'	=> \&MegaCli_fct_v1::deleteport,
    'state'		    => \&MegaCli_info_v1::state,
    'capacity'      => \&MegaCli_info_v1::capacity,
);

my %i686    = (
    '1.01.24' => \%up_stage_v1,
);

my $megacli_exe_name    = "/usr/sbin/MegaCli";

## ###################################
## ########### FONCTIONS #############
## ###################################

######################################
# appel des fonction ds les librairies
# suivant la version de megacli
# prends le nom de la fct et les params
# en parametre

sub call {
    my $name	= shift;
    my @param	= @_;

    my $version = test_version_megacli();

    return 1, "MegaCli NOT PRESENT" unless ( $version );

	if ( exists $i686{ $version } ) {
		if (my @ret = $i686{$version}->{$name}(@param)) {
			return @ret;
		}
		else {
			return -1, "megacli_info_ctl return null expression";
		}
	}
	else {
		return -1, "UNKNOWN MegaCli VERSION";
	}
}

######################################
# test la version de megacli

sub test_version_megacli {
    my $name	= $megacli_exe_name;

    # return 1 si megacli n'est pas present
    return unless ( -e $name );
    return unless ( -x $name );

    # On recupere la version de megacli et on la retourne
    my $version = qx#$name -v -NoLog | grep Ver#;
    if ( $version =~ /Ver\s(\d+\.\d+\.\d+)/ ) {
        return $1;
    }

    return ;
}

## ###################################
## Fonction info_all :
## appel megacli_info et retourne les infos
## si la version est connue

sub info_all {
    return call("info_ctl", @_);
}

## ###################################
## Fonction list_ctl :

sub list_ctl {
    return call("list_ctl", @_);
}

## ###################################
## Fonction list_unit :
## prend un controleur en param

sub list_unit {
    return call("list_unit", @_);
}

## ###################################
## Fonction list_port :
## prend un controleur en param

sub list_port {
    return call("list_port", @_);
}

## ###################################
## Fonction smart :
## prend un controleur et un disk en param

sub smart {
    return call("smart", @_);
}

## ###################################
## Fonction createunit :
##
## createunit($cid, $RaidType, $PidList)

sub createunit {
    return call("createunit", @_);
}

## ###################################
## Fonction deleteunit :
## 
## deleteunit($cid, $uid)

sub deleteunit {
    return call("deleteunit", @_);
}

## ###################################
## Fonction rescan :
## 
## rescan($cid)

sub rescan {
    return call("rescan", @_);
}

## ###################################
## Fonction verify :
## 
## verify($cid, $uid)

sub verify {
   return call("verify", @_);
}

## ###################################
## Fonction alarms :
## 
## alarms([$cid]) 

sub alarms {
    return call("alarms", @_);
}

## ###################################
## Fonction info :
## 
## info()

sub info {
   return call("info", @_);
}

## ###################################
## Fonction rebuilt :
## 
## rebuild($cid, $uid, $pid)

sub rebuild {
	return call("rebuild", @_);
}

## ###################################
## Fonction deleteport :
## 
## deleteport($cid, $pid)

sub deleteport {
    return call("deleteport", @_);
}


## ###################################
## Fonction state :
## 
## state()

sub state {
    return call("state", @_);
}

## ###################################
## Fonction bbu :
sub bbu {
    return 0, "BBU: No bbu with lsi";
}

## ###################################
## Fonction cache :
sub cache {
    return 0, "Cache: No cache with lsi";
}

## ###################################
## Fonction capacity :
sub capacity {
    return call("capacity", @_);
}

1;
