## ######### PROJECT DESCRIPTION : ###
## 
## gestion pour les contrleurs Adaptec
## 
## ###################################
## 
## Made by Florac Emmanuel
## 
## Started on Tue Dec 16 16:44:47 CET 2008 Florac Emmanuel
## 
## 
## ###################################
##

package adaptec;

use strict;
use lib_raid;
use arcconf_v1;

use Data::Dumper;

sub switch {
	# Aiguille en fonction de la version et de la fonction
	
	# Test de la presence des parametres
	return error("Pas assez d'argument") if ( $#_ < 0 );

	# Variable contenant les references des fonctions selon la version
	my %possibility = (
        arcconf_v1	=> {},
    );
    
	%{$possibility{arcconf_v1}} = (
        info		=> \&arcconf_v1::info,
        rescan		=> \&arcconf_v1::rescan,
        deleteport	=> \&arcconf_v1::deleteport,
        deleteunit	=> \&arcconf_v1::deleteunit,
        createunit	=> \&arcconf_v1::createunit,
        rebuild     => \&arcconf_v1::rebuild,
        verify		=> \&arcconf_v1::verify,
        alarms		=> \&arcconf_v1::alarms,
        state		=> \&arcconf_v1::state,
        list_unit	=> \&arcconf_v1::list_unit,
        list_port	=> \&arcconf_v1::list_port,
        smart		=> \&arcconf_v1::smart,
        bbu         => \&arcconf_v1::bbu,
        cache       => \&arcconf_v1::cache,
        capacity    => \&arcconf_v1::capacity,
    );

	my $version	= version();
	my $function	= shift(@_);
	my $ctl		= shift(@_);
	
	# Verification du type de raid
	my @tab_ctl	= split ("_", $ctl );
	$ctl		= pop @tab_ctl;
	my $modele	= pop @tab_ctl;
	
#####################################
# Processur d'aiguillage

	return error( "fonction inconnue" ) unless ( $possibility{$version}{$function} );

	my @retour = $possibility{$version}{$function}->($ctl, @_);
	return @retour;
}

sub list_ctl {
	my $name = shift;
	
	
	
	my ($retour_tware, $tware) = arcconf_v1::list_ctl( $name );

	return $retour_tware, $tware if ( $retour_tware );
	
	my @retour;
	foreach ( @{ $tware} ) {
		my $new_name = $name . "_" . $_;
		push @retour, $new_name;
	}

	return $retour_tware, \@retour;
}

sub info_all {
	my $name	= shift;
	my ($flag, $brand, $ctl, $ctlnum) = split ("_", $name );
	
	my ($retour_tware, $tware) = arcconf_v1::info_all( $ctlnum );

	if ( ! $retour_tware ) {
	    my %retour;
	    $retour{ $name } = $tware->{$ctlnum};

	    return $retour_tware, \%retour;
	}

	return $retour_tware, $tware;
}

sub alarms {
	my $name	= shift;
	my @tab_ctl	= split ("_", $name );
	my $ctl		= pop @tab_ctl;

	return arcconf_v1::alarms( $ctl );
}

sub state {
	my $name	= shift;
	my @tab_ctl	= split ("_", $name );
	my $ctl		= pop @tab_ctl;
	
	return arcconf_v1::state( $ctl );
}

sub version {
# Renvoie la version du raid arcconf
    return "arcconf_v1";
}

1;
