## ######### PROJECT DESCRIPTION : ###
## 
## gestion commande arcconf contrleurs Adaptec ASR
## 
## ###################################
## 
## Made by Florac Emmanuel
## 
## Started on mar dc 16 16:44:47 CET 2008 Florac Emmanuel
## 
## ###################################
##

## ###################################
## Declaration du package

package arcconf_v1;

## ###################################
## Appel des librairies

use	strict;
use	Data::Dumper;

## Liste des lib info
use	Arcconf_info_v1;
# use	Arcconf_fct_v1;

## ###################################
## Declaration de variables


my %up_stage_v1 = (
    'info_ctl'	    => \&Arcconf_info_v1::arcconf_info_ctl,
    'list_ctl'	    => \&Arcconf_info_v1::arcconf_list_ctl,
    'list_unit'	    => \&Arcconf_info_v1::arcconf_list_unit,
    'list_port'	    => \&Arcconf_info_v1::arcconf_list_port,
    'smart'		    => \&Arcconf_info_v1::arcconf_smart,
    'createunit'    => \&Arcconf_fct_v1::createunit,
    'deleteunit'	=> \&Arcconf_fct_v1::deleteunit,
    'rescan'		=> \&Arcconf_fct_v1::rescan,
    'verify'		=> \&Arcconf_fct_v1::verify,
    'alarms'		=> \&Arcconf_fct_v1::alarms,
    'info'		    => \&Arcconf_fct_v1::info,
    'rebuild'	    => \&Arcconf_fct_v1::rebuild,
    'deleteport'	=> \&Arcconf_fct_v1::deleteport,
    'state'		    => \&Arcconf_info_v1::state,
	'bbu'           => \&Arcconf_info_v1::bbu,
    'capacity'      => \&Arcconf_info_v1::capacity,
);

my %i686    = (
    '5.20' => \%up_stage_v1,
    );

my $arcconf_exe_name    = "/usr/sbin/arcconf";

## ###################################
## ########### FONCTIONS #############
## ###################################

######################################
# appel des fonction ds les librairies
# suivant la version de arcconf
# prends le nom de la fct et les params
# en parametre

sub call {
    my $name	= shift;
    my @param	= @_;

    my $version = test_version_arcconf();

    return 1, "ARCCONF NOT PRESENT" unless ( $version );

	if ( exists $i686{ $version } ) {
		if (my @ret = $i686{$version}->{$name}(@param)) {
			return @ret;
		}
		else {
			return -1, "arcconf_info_ctl return null expression";
		}
	}
	else {
		return -1, "UNKNOWN ARCCONF VERSION";
	}
}

######################################
# test la version de arcconf

sub test_version_arcconf {
    my $name	= $arcconf_exe_name;

    # return 1 si arcconf n'est pas present
    return unless ( -e $name );
    return unless ( -x $name );

    # On recupere la version de arcconf et on la retourne
    my @version=qx(arcconf); 
	foreach ( @version ) {
	 	if ( m/^\s+\|\s+UCLI\s+\|\s+Version\s(\d+\.\d+)/ ) {
			return $1;
		}
	}

    return ;
}

## ###################################
## Fonction info_all :
## appel arcconf_info et retourne les infos
## si la version est connue

sub info_all {
    return call("info_ctl", @_);
}

## ###################################
## Fonction list_ctl :

sub list_ctl {
    return call("list_ctl", @_);
}

## ###################################
## Fonction list_unit :
## prend un controleur en param

sub list_unit {
    return call("list_unit", @_);
}

## ###################################
## Fonction list_port :
## prend un controleur en param

sub list_port {
    return call("list_port", @_);
}

## ###################################
## Fonction smart :
## prend un controleur et un disk en param

sub smart {
    return 0, "smart: Not implemented";
}

## ###################################
## Fonction createunit :
##
## createunit($cid, $RaidType, $PidList)

sub createunit {
    return 0, "createunit: Not implemented";
}

## ###################################
## Fonction deleteunit :
## 
## deleteunit($cid, $uid)

sub deleteunit {
    return 0, "deleteunit: Not implemented";
}

## ###################################
## Fonction rescan :
## 
## rescan($cid)

sub rescan {
    return 0, "rescan: Not implemented";
}

## ###################################
## Fonction verify :
## 
## verify($cid, $uid)

sub verify {
    return 0, "verify: Not implemented";
}

## ###################################
## Fonction alarms :
## 
## alarms([$cid]) 

sub alarms {
    return call("alarms", @_);
}

## ###################################
## Fonction info :
## 
## info()

sub info {
   return call("info", @_);
}

## ###################################
## Fonction rebuilt :
## 
## rebuild($cid, $uid, $pid)

sub rebuild {
    return 0, "rebuild: Not implemented";
}

## ###################################
## Fonction deleteport :
## 
## deleteport($cid, $pid)

sub deleteport {
    return 0, "deleteport: Not implemented";
}


## ###################################
## Fonction state :
## 
## state()

sub state {
    return call("state", @_);
}

## ###################################
## Fonction bbu :
sub bbu {
    return call("bbu", @_);
}

## ###################################
## Fonction cache :
sub cache {
    return 0, "Cache: Not implemented";
}

## ###################################
## Fonction capacity :
sub capacity {
    return 0, "capacity: Not implemented";
}

1;
