## ######### PROJECT DESCRIPTION : ###
## 
## gestion pour les carte lsi
## 
## ###################################
## 
## Made by Pujos Sylvain
## 
## Started on  Mon May 28 13:23:04 2007 Pujos Sylvain
## Last update Mon May 28 13:26:45 2007 Pujos Sylvain
## 
## ###################################
##


package lsi;

use strict;
use MegaCli_v1;
use lib_raid;


sub switch {
	# Aiguille en fonction de la version et de la fonction

	# Test de la presence des parametres
	return error("Pas assez d'argument") if ( $#_ < 0 );

	# Variable contenant les references des fonctions selon la version
	my %possibility = (
        MegaCli_v1	=> {},
    );
    
	%{$possibility{MegaCli_v1}} = (
        info		=> \&MegaCli_v1::info,
        rescan		=> \&MegaCli_v1::rescan,
        deleteport	=> \&MegaCli_v1::deleteport,
        deleteunit	=> \&MegaCli_v1::deleteunit,
        createunit	=> \&MegaCli_v1::createunit,
        rebuild     => \&MegaCli_v1::rebuild,
        verify		=> \&MegaCli_v1::verify,
        alarms		=> \&MegaCli_v1::alarms,
        state		=> \&MegaCli_v1::state,
        list_unit	=> \&MegaCli_v1::list_unit,
        list_port	=> \&MegaCli_v1::list_port,
        smart		=> \&MegaCli_v1::smart,
        bbu         => \&MegaCli_v1::bbu,
        cache       => \&MegaCli_v1::cache,
        capacity    => \&MegaCli_v1::capacity,
    );

	my $version	= version();
	my $function	= shift(@_);
	my $ctl		= shift(@_);
	
	# Verification du type de raid
	my @tab_ctl	= split ("_", $ctl );
	$ctl		= pop @tab_ctl;
	my $modele	= pop @tab_ctl;
	
#####################################
# Processur d'aiguillage

	return error( "fonction inconnue" ) unless ( $possibility{$version}{$function} );

	my @retour = $possibility{$version}{$function}->($ctl, @_);
	return @retour;
}

sub list_ctl {
	my $name = shift;
	
	my ($retour_tware, $tware) = MegaCli_v1::list_ctl( $name );

	return $retour_tware, $tware if ( $retour_tware );
	
	my @retour;
	foreach ( @{ $tware} ) {
		my $new_name = $name . "_" . $_;
		push @retour, $new_name;
	}
	
	return $retour_tware, \@retour;
}

sub info_all {
	my $name	= shift;
	my @tab_ctl	= split ("_", $name );
	my $ctl		= pop @tab_ctl;

	my ($retour_tware, $tware) = MegaCli_v1::info_all( $ctl );

	if ( ! $retour_tware ) {
	    my %retour;
	    $retour{ $name } = $tware->{$ctl};

	    return $retour_tware, \%retour;
	}

	return $retour_tware, $tware;
}

sub alarms {
	my $name	= shift;
	my @tab_ctl	= split ("_", $name );
	my $ctl		= pop @tab_ctl;

	return MegaCli_v1::alarms( $ctl );
}

sub state {
	my $name	= shift;
	my @tab_ctl	= split ("_", $name );
	my $ctl		= pop @tab_ctl;
	
	return MegaCli_v1::state( $ctl );
}

sub version {
# Renvoie la version du raid MegaCli
    return "MegaCli_v1";
}

1;
