## ######### PROJECT NAME : ##########
## 
## raid_logiciel.pm for  in /home/dayan/intellique/raid
## 
## ######### PROJECT DESCRIPTION : ###
## 
## raid logiciel
## 
## ###################################
## 
## Made by Dayan Romain
## Login   <dayan@intellique.com>
## 
## Started on  Tue Jul 19 09:14:35 2005 Dayan Romain
## Last update Tue Oct 17 16:14:49 2006 Pujos Sylvain
## 
## ###################################
##

package raid_lvm;

use strict;
use raid_lvm_v1;
use lib_raid;

use Data::Dumper;

sub switch {
    # Aiguille en fonction de la version et de la fonction

    # Test de la presence des parametres
	return error( "Not enough argument" ) if ( $#_ < 0 );

    #####################################
    # Declaration de variables

	# Variable contenant les references des fonctions selon la version
	my %possibility = (
        "raid_lvm_v1"	=> {
            info		=> \&raid_lvm_v1::info,
            rescan		=> \&raid_lvm_v1::rescan,
            deleteport	=> \&raid_lvm_v1::deleteport,
            deleteunit	=> \&raid_lvm_v1::deleteunit,
            createunit	=> \&raid_lvm_v1::createunit,
            rebuild		=> \&raid_lvm_v1::rebuild,
            verify		=> \&raid_lvm_v1::verify,
            alarms		=> \&raid_lvm_v1::alarms,
            state		=> \&raid_lvm_v1::state,
            list_unit	=> \&raid_lvm_v1::list_unit,
            list_port	=> \&raid_lvm_v1::list_port,
            smart		=> \&raid_lvm_v1::smart,
            bbu         => \&raid_lvm_v1::bbu,
            cache       => \&raid_lvm_v1::cache,
            capacity    => \&raid_lvm_v1::capacity,
        }
    );


    #####################################
	my $version	= version();
	my $function	= shift(@_);

    #####################################
    # Processus d'aiguillage
	return error( "Function unknown" ) unless ( $possibility{ $version }{ $function } );
	return $possibility{ $version }{ $function }->( @_ );
}

sub info_all {
	# Un parametre est fourni
	my $name = shift;

	my %retour;
	my ($retour_lvm, $lvm) = raid_lvm_v1::info( $name );

	if ( $retour_lvm == 1 ) {
		return error( $lvm );
	}
	
	foreach ( keys %{ $lvm }) {
		$retour{$_} = $lvm->{$_};
	}

	return ok( \%retour );
}

sub version {
# Renvoie la version 

    return "raid_lvm_v1";
}

sub list_ctl {
	# Un parametre est fourni
	my $name = shift;

	if ( lvm_exist() ) {
		my @retour;
	    my @file = qx#/sbin/vgdisplay 2> /dev/null#;
		if ( ! $file[0] ) {
			push @retour, $name;
			return ok( \@retour );
		}

		foreach (@file) {
			push @retour, $name ."_". $1 if ( m/^\s*VG\s+Name\s+(\w+)/ );
		}

		return ok( \@retour );
	}

	return error( undef );
}

sub lvm_exist {
    return 1;

}

1;
