
## ######### PROJECT NAME : ##########
## 
## raid_logiciel_v1.pm for  in /home/dayan/intellique/raid
## 
## ######### PROJECT DESCRIPTION : ###
## 
## raid logiciel
## 
## ###################################
## 
## Made by Dayan Romain
## Login   <dayan@intellique.com>
## 
## Started on  Tue Jul 19 09:14:35 2005 Pujos Sylvain
## Last update Fri Feb 22 17:44:59 2008 Boutonnet Alexandre
## 
## ###################################
##

package raid_lvm_v1;

use strict;
use warnings;

use raid_lvm_info_v1;
use raid_lvm_fct_v1;
use lib_raid;



#########################################

# Outils de debug et d'affichage

#########################################

sub affiche {
# Creer au bon format le message de retour

    my $level = shift;
    
    my $param = join "\n", @_;
    my @etat = ($level, $param);
    return \@etat;
}


## ###################################
## Declaration de variables


my %up_stage_v1	= (
    'list_unit'     => \&raid_lvm_info_v1::list_unit,
    'list_port'     => \&raid_lvm_info_v1::list_port,
    'info'          => \&raid_lvm_info_v1::info,
    'smart'         => \&raid_lvm_fct_v1::smart,
    'createunit'    => \&raid_lvm_fct_v1::createunit,
    'deleteunit'    => \&raid_lvm_fct_v1::deleteunit,
    'rescan'        => \&raid_lvm_fct_v1::rescan,
    'verify'        => \&raid_lvm_fct_v1::verify,
    'alarms'        => \&raid_lvm_fct_v1::alarms,
    'rebuild'       => \&raid_lvm_fct_v1::rebuild,
    'deleteport'    => \&raid_lvm_fct_v1::deleteport,
    'state'         => \&raid_lvm_fct_v1::state,
    'capacity'      => \&raid_lvm_fct_v1::capacity,
);

## ###################################
## ########### FONCTIONS #############
## ###################################

######################################
# appel des fonction ds les librairies
# prends le nom de la fct et les params
# en parametre

sub call {
    my $name	= shift;
    my @param	= @_;

	if (my @ret = $up_stage_v1{$name}(@param)) {
		return @ret;
	}
	return -1, "lvm return null expression";
}


## ###################################
## Fonction info_all :
## appel megacli_info et retourne les infos
## si la version est connue
sub info_all {
    return call("info_ctl", @_);
}

## ###################################
## Fonction list_unit :
## prend un controleur en param
sub list_unit {
    return call("list_unit", @_);
}

## ###################################
## Fonction list_port :
## prend un controleur en param
sub list_port {
    return call("list_port", @_);
}

## ###################################
## Fonction smart :
## prend un controleur et un disk en param
sub smart {
    return call("smart", @_);
}

## ###################################
## Fonction bbu :
## ne fonctionne pas avec lvm
sub bbu {
    return 0, "BBU: No bbu with lvm";
}

## ###################################
## Fonction cache :
## ne fonctionne pas avec lvm
sub cache {
    return 0, "Cache: No cache with lvm";
}

## ###################################
## Fonction capacity :
## prend un controleur en param
sub capacity {
    return call("capacity", @_);
}

## ###################################
## Fonction createunit :
##
## createunit($cid, $RaidType, $PidList)
sub createunit {
    return call("createunit", @_);
}

## ###################################
## Fonction deleteunit :
## 
## deleteunit($cid, $uid)
sub deleteunit {
    return call("deleteunit", @_);
}

## ###################################
## Fonction rescan :
## 
## rescan($cid)
sub rescan {
    return call("rescan", @_);
}

## ###################################
## Fonction verify :
## 
## verify($cid, $uid)
sub verify {
   return call("verify", @_);
}

## ###################################
## Fonction alarms :
## 
## alarms([$cid]) 
sub alarms {
    return call("alarms", @_);
}

## ###################################
## Fonction info :
## 
## info()
sub info {
	my $name	= shift;
	my @tab_ctl	= split ("_", $name );
	my $ctl		= pop @tab_ctl;
	
	my ($retour_lvm, $lvm) = call("info", $ctl, @_);

	if ( ! $retour_lvm ) {
	    my %retour;
	    $retour{ $name } = $lvm->{$ctl};
	    return $retour_lvm, \%retour;
	}

	return $retour_lvm, $lvm;
	
}

## ###################################
## Fonction rebuilt :
## 
## rebuild($cid, $uid, $pid)
sub rebuild {
	return call("rebuild", @_);
}

## ###################################
## Fonction deleteport :
## 
## deleteport($cid, $pid)
sub deleteport {
    return call("deleteport", @_);
}


## ###################################
## Fonction state :
## 
## state()
sub state {
    return call("state", @_);
}

1;
