#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
## 
## raid_materiel.pm for raide_materiel in /home/dayan/intellique/raid/wip
## 
## ######### PROJECT DESCRIPTION : ###
## 
## aiguillage vers les fonctions de raid materiel
## 
## ###################################
## 
## Made by Dayan Romain
## Login   <dayan@intellique.com>
## 
## Started on  Wed Aug 31 10:46:57 2005 Dayan Romain
## Last update Tue Dec 16 16:40:37 2008 Florac Emmanuel
## 
## ###################################
##


package raid_materiel;

use strict;
use lib_raid;
use tware;
use lsi;
use xyratex;
use adaptec;

my %list_marque		= (
    "3ware"		=> \&tware::switch,
    "lsi"		=> \&lsi::switch,
    "xyratex"		=> \&xyratex::switch,
    "adaptec"		=> \&adaptec::switch,
);

my %module_list_ctl	= (
    "3ware"		=> \&tware::list_ctl,
    "lsi"		=> \&lsi::list_ctl,
    "xyratex"		=> \&xyratex::list_ctl,
    "adaptec"		=> \&adaptec::list_ctl,
);

my %module_info_all	= (
    "3ware"		=> \&tware::info_all,
    "lsi"		=> \&lsi::info_all,
    "xyratex"		=> \&xyratex::info_all,
    "adaptec"		=> \&adaptec::info_all,
);

my %module_alarms   = (
    "3ware"		=> \&tware::alarms,
    "lsi"		=> \&lsi::alarms,
    "xyratex"		=> \&xyratex::alarms,
    "adaptec"		=> \&adaptec::alarms,
);

my %module_state    = (
    "3ware"		=> \&tware::state,
    "lsi"		=> \&lsi::state,
    "xyratex"		=> \&xyratex::state,
    "adaptec"		=> \&adaptec::state,
);


sub switch {
# Aiguille en fonction de la version et de la fonction
	my $fonction	= $_[0];
	my $ctl		= $_[1];

	# Test de la presence des parametres
	return error( "Not enough argument" ) if ( $#_ < 0 );

	return action_sur_module( \%list_marque, $ctl, @_ );
}


sub list_ctl {
    # Un parametre est fourni
    my $name = shift;

    my @retour;
    foreach ( keys %list_marque ) {
        my ($retour_marque, $marque) = $module_list_ctl{ $_ }->( $name . "_" . $_ );

        push @retour, @{ $marque} if ( ( ! $retour_marque ) && ( @{ $marque} ) );
        return error_and_stop( $marque ) if ( $retour_marque == -1 );
    }

    return ok( \@retour );
}


sub info_all {
    return action_sur_module( \%module_info_all, $_[0], @_ );
}

sub alarms {
    return action_sur_module( \%module_alarms, $_[0], @_ );
}

sub state {
    return action_sur_module( \%module_state, $_[0], @_ );
}


#############################################

# Fonction locale

#############################################

sub action_sur_module {
	my $module = shift;

	# Un parametre est fourni
	my $name = shift;

	# Verification du type de raid
	my @tab_name = split ("_", $name );

	if ( exists $list_marque{ $tab_name[1] } ) {
		return $module->{ $tab_name[1] }->( @_ );
	}
	# Sinon le Raid n'est pas un type connu
	return error( "Invalid controler name" );
}

1;
