## ######### PROJECT NAME : ##########
##
## raid_smart.pm
##
## ######### PROJECT DESCRIPTION : ###
##
## Module de gestion du smart
##
## ###################################
##
## Made by Pujos Sylvain
##
## ###################################
##

package raid_smart;

use strict;

#########################################
#### LEVEL
#    3   => "UNKNOWN",
#    2   => "CRITICAL",
#    1   => "WARNING",
#    0   => "OK",
#    -1  => "UNKNOWN",

#########################################

my %code = (
    "OK"		=> [0,0],
    "Ok"		=> [0,0],

    "Device open failed, or device did not return an IDENTIFY DEVICE structure" => [1,2],
    "Some SMART command to the disk failed. Perhaps, this disk is not present"  => [2,2],
    "This disk is FAILING"                                                      => [3,2],
    "This disk is PRE-FAILING"                                                  => [4,1],
    "This disk is PRE-FAILING"                                                  => [5,1],
    "The device error log contains records of errors"                           => [6,1],
    "The device self-test log contains records of errors"                       => [7,1],

    "NOT-EXIST"                 => [11,2],
    "Controller doesn't EXIST"	=> [12,2],
    "Controller is NOT OPTIMAL" => [13,2],

    "NOT-PRESENT"				=> [21,2],

    "VERIFYING"					=> [31,1],
    "INITIALIZING"				=> [32,1],
    "INIT-PAUSED"				=> [33,1],
    "REBUILDING"				=> [34,1],
    "REBUILD-PAUSED"			=> [35,1],
    "DEGRADED"					=> [36,1],
    "MIGRATING"					=> [37,1],
    "MIGRATE-PAUSED"			=> [38,1],
    "RECOVERY"					=> [39,1],
    "REBUILD-VERIFY"            => [40,1],

    "INOPERABLE"				=> [50,2],
    "UNKNOWN"					=> [51,3],
    "SMART-FAILURE"				=> [52,2],
    "ECC-ERROR"					=> [53,2],

    "Testing"                   => [71,1],
    "Charging"                  => [72,1],

);

#########################################

sub translate_code_to_level{
    my $code_r	= shift;

    foreach my $k ( keys %code ) {
        return $code{ "$k" }->[1] if ( $code_r == $code{ "$k" }->[0] );
    }
    
    return -1;
}

sub translate_code_to_text{
    my $code_r	= shift;

    foreach my $k ( keys %code ) {
        return $k if ( $code_r == $code{ "$k" }->[0] );
    }

    return "BAD CODE";
}

sub translate_text_to_code{
    return 51 unless exists $code{$_[0]}->[0];
    return $code{$_[0]}->[0];
}

1;
