#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
## 
## tw_cli_fct_i686_v1.pm for lib i686 tw_cli
## 
## ######### PROJECT DESCRIPTION : ###
## 
## lib i686 tw_cli
## 
## ###################################
##

## ###################################
## Declaration du package

package tw_cli_fct_i686_v1;

## ###################################
## Appel des librairies

use	strict;

## ###################################
## Declaration de variables

my $tw_cli_name	= "tw_cli";


## ###################################
## Fonction createunit :
##
## createunit($cid, $RaidType, $PidList)

sub createunit {
    my ($ctl, $raid, @arg)	= @_;

    my $params	= $ctl." r".$raid." ";

    my $port_liste = "";

    foreach my $args (@arg) {
        $params .= " ".$args and next if ($args !~ /^p/);
        $args =~ s/p//;
        $port_liste .= "$args:";
    }
    
    chop($port_liste);
    $params .= " p".$port_liste;

    my $ret = qx#$tw_cli_name maint createunit $params 2>&1#;
    if ($?) {
        return 1, $ret;
    } elsif ($? eq 0) {
        return 0, $ret;
    }
    return -1, "createunit ERROR : $tw_cli_name maint createunit $params";
}


## ###################################
## Fonction deleteunit :
## 
## deleteunit($cid, $uid)

sub deleteunit {
    my $arg = join (" ", @_);
    
    my $ret = qx#$tw_cli_name maint deleteunit $arg 2>&1#;
   
    if ($?) {
        return 1, $ret;
    } elsif ($? eq 0) {
        return 0, $ret;
    }
    
    return -1, "deleteunit ERROR : $tw_cli_name maint deleteunit $arg";
}


## ###################################
## Fonction rescan :
## 
## rescan($cid)

sub rescan {
    my $arg = join (" ", @_);
    
    my $ret = qx#$tw_cli_name maint rescan $arg 2>&1#;
    if ($?) {
        return 1, $ret;
    } elsif ($? eq 0) {
        return 0, $ret;
    }
  
  return -1, "rescan ERROR : $tw_cli_name maint rescan $arg";
}


## ###################################
## Fonction verify :
## 
## verify($cid, $uid)

sub verify {
    my $arg = join (" ", @_);

    my $ret = qx#$tw_cli_name maint verify $arg 2>&1#;
    if ($?) {
        return 1, $ret;
    } elsif ($? eq 0) {
        return 0, $ret;
    }
    
    return -1, "verify ERROR : $tw_cli_name maint verify $arg";
}

## ###################################
## Fonction alarms :
## 
## alarms([$cid]) 

sub alarms {
    my $arg = join (" ", @_);

    my @ret = qx#$tw_cli_name alarms $arg 2>&1#;
    @ret = grep {($_ =~ m/^$arg/)} @ret; 

    if ($?) {
    	return 1, join ("", @ret);
    } elsif ($? eq 0) {
	    return 0, join ("", @ret);
    }
    
    return -1, "alarms ERROR : $tw_cli_name alarms $arg";
}

## ###################################
## Fonction info :
## 
## info()

sub info {
    my $arg = join (" ", @_);
    
    my $ret = qx#$tw_cli_name info $arg 2>&1#;
    if ($?) {
        return 1, $ret;
    } elsif ($? eq 0) {
        return 0, $ret;
    }
    
    return -1, "info ERROR : $tw_cli_name info $arg";
}

## ###################################
## Fonction rebuilt :
## 
## rebuild($cid, $uid, $pid)

sub rebuild {
    my $arg = join (" ", @_);

    my $ret = qx#$tw_cli_name maint rebuild $arg 2>&1#;
    if ($?) {
        return 1, $ret;
    } elsif ($? eq 0) {
        return 0, $ret;
    }

    return -1, "rebuild ERROR : $tw_cli_name maint rebuild $arg";
}

## ###################################
## Fonction deleteport :
## 
## deleteport($cid, $pid)

sub deleteport {
    my $arg = join (" ", @_);

    my $ret = qx#$tw_cli_name maint remove $arg 2>&1#;

    if ($?) {
        return 1, $ret;
    }
    elsif ($? eq 0) {
        return 0, $ret;
    }

    return -1, "deleteport ERROR : $tw_cli_name maint remove $arg";
}

## ###################################
## Fonction bbu :
## 
## bbu()

sub bbu {
	my $ctl		= shift;

	if ( @_ ) {
		my $action = shift;
		my $ret = qx#$tw_cli_name /$ctl/bbu $action quiet 2>&1#;

		if ($?) {
			return 1, $ret;
		} elsif ($? eq 0) {
			chomp $ret;
			chomp $ret;
			return 0, $ret;
		}
    
		return -1, "bbu ERROR : $tw_cli_name /$ctl/bbu $action quiet";
	    
	}
	else {
		my $ret = qx#$tw_cli_name /$ctl/bbu show 2>&1#;

		if ($?) {
			return 1, $ret;
		} elsif ($? eq 0) {
			chomp $ret;
			return 0, $ret;
		}
    
		return -1, "bbu ERROR : $tw_cli_name /$ctl/bbu show";
	}
}

## ###################################
## Fonction cache :

sub cache {
	my $ctl		= shift;
	my $unit	= shift;
	
	if ( @_ ) {
		my $action = shift;
		my $ret = qx#$tw_cli_name /$ctl/$unit set cache=$action 2>&1#;

		if ($?) {
			return 1, $ret;
		} elsif ($? eq 0) {
			chomp $ret;
			chomp $ret;
			return 0, $ret;
		}
    
		return -1, "cache ERROR : $tw_cli_name /$ctl/$unit set cache=$action";
	    
	}
	else {
		my $ret = qx#$tw_cli_name /$ctl/$unit show cache 2>&1#;

		if ($?) {
			return 1, $ret;
		} elsif ($? eq 0) {
			chomp $ret;
			chomp $ret;
			return 0, $ret;
		}
    
		return -1, "cache ERROR : $tw_cli_name /$ctl/$unit show cache";
	}
}

1;
