#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
## 
## tware.pm for tware in /home/dayan/intellique/raid/wip
## 
## ######### PROJECT DESCRIPTION : ###
## 
## gestion pour les carte 3ware
## 
## ###################################
## 
## Made by Dayan Romain
## Login   <dayan@intellique.com>
## 
## Started on  Wed Aug 31 12:44:25 2005 Dayan Romain
## Last update Tue Oct 17 16:30:44 2006 Pujos Sylvain
## 
## ###################################
##


package tware;

use strict;
use tw_cli_v1;
use lib_raid;

our $modele;

sub switch {
	# Aiguille en fonction de la version et de la fonction

	# Test de la presence des parametres
	return error("Not enough argument") if ( $#_ < 0 );

	# Variable contenant les references des fonctions selon la version
	my %possibility = (
				tw_cli_v1	=> {},
			);
    
	%{$possibility{tw_cli_v1}} = (
        info		=> \&tw_cli_v1::info,
        rescan		=> \&tw_cli_v1::rescan,
        deleteport	=> \&tw_cli_v1::deleteport,
        deleteunit	=> \&tw_cli_v1::deleteunit,
        createunit	=> \&tw_cli_v1::createunit,
        rebuild     => \&tw_cli_v1::rebuild,
        verify		=> \&tw_cli_v1::verify,
        alarms		=> \&tw_cli_v1::alarms,
        state		=> \&tw_cli_v1::state,
        list_unit	=> \&tw_cli_v1::list_unit,
        list_port	=> \&tw_cli_v1::list_port,
        smart		=> \&tw_cli_v1::smart,
        bbu         => \&tw_cli_v1::bbu,
        cache       => \&tw_cli_v1::cache,
        capacity    => \&capacity,
    );

	my $version	= version();
	my $function	= shift(@_);
	my $ctl		= shift(@_);
	
	# Verification du type de raid
	my @tab_ctl	= split ("_", $ctl );
	$ctl		= pop @tab_ctl;
	$modele	= pop @tab_ctl;
	
#####################################
# Processur d'aiguillage

	return error( "function unknown" ) unless ( $possibility{$version}{$function} );

	if ( $function eq "createunit" ) {
		my $type_raid = shift @_ ;

		if ( $modele =~ m/^9/ ) {
			$type_raid = "single" if ( $type_raid eq "jbod" );
		}
		elsif ( $modele =~ m/^8/ ) {
			$type_raid = "jbod" if ( $type_raid eq "single" );
		}
		elsif ( $modele =~ m/^7/ ) {
			$type_raid = "jbod" if ( $type_raid eq "single" );
		}

		unshift @_, $type_raid;
	}

	my @retour = $possibility{$version}{$function}->($ctl, @_);
	
	return @retour;
}

sub list_ctl {
	my $name = shift;
	
	my ($retour_tware, $tware) = tw_cli_v1::list_ctl( $name );

	return $retour_tware, $tware if ( $retour_tware );
	
	my @retour;
	foreach ( @{ $tware} ) {
		my $new_name = $name . "_" . $_;
		push @retour, $new_name;
	}
	
	return $retour_tware, \@retour;
}

sub info_all {
	my $name	= shift;
	my @tab_ctl	= split ("_", $name );
	my $ctl		= pop @tab_ctl;

	my ($retour_tware, $tware) = tw_cli_v1::info_all( $ctl );

	if ( ! $retour_tware ) {
	    my %retour;
	    $retour{ $name } = $tware->{$ctl};

	    return $retour_tware, \%retour;
	}

	return $retour_tware, $tware;
}

sub alarms {
	my $name	= shift;
	my @tab_ctl	= split ("_", $name );
	my $ctl		= pop @tab_ctl;

	return tw_cli_v1::alarms( $ctl );
}

sub state {
	my $name	= shift;
	my @tab_ctl	= split ("_", $name );
	my $ctl		= pop @tab_ctl;
	
	return tw_cli_v1::state( $ctl );
}

sub version {
# Renvoie la version du raid logiciel   

    return "tw_cli_v1";
}

sub capacity {
    # Renvoie les capacites raids de la carte
    my @raid = ( "single", "spare", "raid0", "raid1", "raid10", "raid5", "raid50");

    if ( $modele =~ m/^96/ ) {
        push @raid, "raid6";
    }

    return 0, \@raid;
}

1;
